## xeus-zmq 1.1.0

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille, Sylvain Corlay, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.8)
project(xeus-zmq)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
set(XEUS_ZMQ_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(XEUS_ZMQ_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(XEUS_ZMQ_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)

# Versionning
# ===========

# Project version
file(STRINGS "${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp" xeus_zmq_version_defines
     REGEX "#define XEUS_ZMQ_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xeus_zmq_version_defines})
    if(ver MATCHES "#define XEUS_ZMQ_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XEUS_ZMQ_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_ZMQ_VERSION
    ${XEUS_ZMQ_VERSION_MAJOR}.${XEUS_ZMQ_VERSION_MINOR}.${XEUS_ZMQ_VERSION_PATCH})
message(STATUS "xeus version: v${XEUS_ZMQ_VERSION}")

# Binary version
# See the following URL for explanations about the binary versionning
# https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info
file(STRINGS "${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp" xeus_zmq_version_defines
    REGEX "#define XEUS_ZMQ_BINARY_(CURRENT|REVISION|AGE)")
foreach(ver ${xeus_zmq_version_defines})
    if(ver MATCHES "#define XEUS_ZMQ_BINARY_(CURRENT|REVISION|AGE) +([^ ]+)$")
        set(XEUS_ZMQ_BINARY_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_ZMQ_BINARY_VERSION
    ${XEUS_ZMQ_BINARY_CURRENT}.${XEUS_ZMQ_BINARY_REVISION}.${XEUS_ZMQ_BINARY_AGE})
message(STATUS "xeus binary version: v${XEUS_ZMQ_BINARY_VERSION}")

# Build options
# =============

# Compilation options
option(XEUS_ZMQ_BUILD_SHARED_LIBS "Build xeus shared library." ON)
option(XEUS_ZMQ_BUILD_STATIC_LIBS "Build xeus static library (default if BUILD_SHARED_LIBS is OFF)." ON)
option(XEUS_ZMQ_STATIC_DEPENDENCIES "link statically with xeus dependencies" OFF)

# Test options
option(XEUS_ZMQ_BUILD_TESTS "xeus test suite" OFF)

# Static build configuration
# ==========================

if (XEUS_ZMQ_STATIC_DEPENDENCIES)
    set(CPPZMQ_TARGET_NAME cppzmq-static)
    set(XEUS_TARGET_NAME xeus-static)
    set(OPENSSL_USE_STATIC_LIBS ON CACHE BOOL "Linking statically with OpenSSL")
else()
    set(CPPZMQ_TARGET_NAME cppzmq)
    set(XEUS_TARGET_NAME xeus)
    set(OPENSSL_USE_STATIC_LIBS OFF CACHE BOOL "Not linking statically with OpenSSL")
endif()

# Print build configuration
# ==========================

message(STATUS "XEUS_ZMQ_BUILD_SHARED_LIBS:          ${XEUS_ZMQ_BUILD_SHARED_LIBS}")
message(STATUS "XEUS_ZMQ_BUILD_STATIC_LIBS:          ${XEUS_ZMQ_BUILD_STATIC_LIBS}")
message(STATUS "XEUS_ZMQ_STATIC_DEPENDENCIES:        ${XEUS_ZMQ_STATIC_DEPENDENCIES}")  
message(STATUS "XEUS_ZMQ_BUILD_TESTS:                ${XEUS_ZMQ_BUILD_TESTS}")  

# Dependencies
# ============

set(xeus_REQUIRED_VERSION 3.0.0)
set(nlohmann_json_REQUIRED_VERSION 3.2.0)
set(cppzmq_REQUIRED_VERSION 4.8.1)
set(zeromq_REQUIRED_VERSION 4.3.2)

if (NOT TARGET xeus AND NOT TARGET xeus-static)
    find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET nlohmann_json)
    find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET cppzmq AND NOT TARGET cppzmq-static)
    find_package(cppzmq ${cppzmq_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET libzmq AND NOT TARGET libzmq-static)
    if (WIN32)
        find_package(zeromq ${zeromq_REQUIRED_VERSION} REQUIRED)
    else ()
        find_package(zeromq ${zeromq_REQUIRED_VERSION} QUIET)

        if (NOT ZeroMQ_FOUND)
            message(STATUS "CMake libzmq package not found, trying again with pkg-config")
            find_package(PkgConfig)
            pkg_check_modules(ZeroMQ libzmq>=${zeromq_REQUIRED_VERSION} REQUIRED)
            set(ZeroMQ_VERSION ${PC_LIBZMQ_VERSION})
            find_library(ZeroMQ_LIBRARY NAMES libzmq.so libzmq.dylib libzmq.dll
                 PATHS ${PC_LIBZMQ_LIBDIR} ${PC_LIBZMQ_LIBRARY_DIRS})
            find_library(ZeroMQ_STATIC_LIBRARY NAMES libzmq-static.a libzmq.a libzmq.dll.a
                 PATHS ${PC_LIBZMQ_LIBDIR} ${PC_LIBZMQ_LIBRARY_DIRS})
            message(STATUS "STATIC_LIBRARY" {ZeroMQ_LIBRARY})
            message(STATUS "STATIC_STATIC_LIBRARY" {ZeroMQ_STATIC_LIBRARY})
         endif ()
    endif ()
endif ()

find_package(OpenSSL REQUIRED)

# Source files
# ============

set(XEUS_ZMQ_HEADERS
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xauthentication.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdebugger_base.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdap_tcp_client.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_control_main.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xmiddleware.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_shell_main.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq_split.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xthread.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_context.hpp
    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_serializer.hpp
)

set(XEUS_ZMQ_SOURCES
    ${XEUS_ZMQ_SOURCE_DIR}/xauthentication.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xdap_tcp_client.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xdebugger_base.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xmiddleware.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_control_main.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_shell_main.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq_split.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xshell.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xshell.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_context.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.hpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.cpp
    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_serializer.cpp
)

# Targets and link
# ================

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if (XEUS_ZMQ_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE)
	# Explicitly finds and links with libsodium.a
	# because it is not exported as a dependency by
	# the static build of libzmq. Remove this when
	# it is fixed upstream.
	set(sodium_USE_STATIC_LIBS ON)
	find_package(sodium REQUIRED)
endif ()

macro(xeus_zmq_create_target target_name linkage output_name)
    string(TOUPPER "${linkage}" linkage_upper)

    if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
        message(FATAL_ERROR "Invalid library linkage: ${linkage}")
    endif ()

    # Output
    # ======

    add_library(${target_name} ${linkage_upper} ${XEUS_ZMQ_SOURCES} ${XEUS_ZMQ_HEADERS})

    target_include_directories(
        ${target_name}
        PUBLIC $<BUILD_INTERFACE:${XEUS_ZMQ_INCLUDE_DIR}>
        $<INSTALL_INTERFACE:include>
    )

    target_link_libraries(
        ${target_name}
        PUBLIC ${CPPZMQ_TARGET_NAME}
        PUBLIC nlohmann_json::nlohmann_json
        PUBLIC OpenSSL::Crypto
        PUBLIC ${XEUS_TARGET_NAME}
    )

    if (NOT MSVC)
        if (APPLE)
            target_link_libraries(${target_name} PUBLIC "-framework CoreFoundation")
        else ()
            if (XEUS_ZMQ_STATIC_DEPENDENCIES)
                target_link_libraries(${target_name} PUBLIC ${sodium_LIBRARY_RELEASE})
            endif ()
        endif ()
    endif ()

    if (UNIX)
        # CMake does not compute the version number of so files as libtool
        # does on Linux. Strictly speaking, we should exclude FreeBSD and
        # Apple from this, but that would require having different version
        # numbers depending on the platform. We prefer to follow the
        # libtool pattern everywhere.
        math(EXPR XEUS_ZMQ_BINARY_COMPATIBLE "${XEUS_ZMQ_BINARY_CURRENT} - ${XEUS_ZMQ_BINARY_AGE}")
        set_target_properties(
            ${target_name}
            PROPERTIES
            PUBLIC_HEADER "${XEUS_ZMQ_HEADERS}"
            COMPILE_OPTIONS "-fvisibility=hidden"
            COMPILE_DEFINITIONS "XEUS_ZMQ_EXPORTS"
            PREFIX ""
            VERSION
            "${XEUS_ZMQ_BINARY_COMPATIBLE}.${XEUS_ZMQ_BINARY_REVISION}.${XEUS_ZMQ_BINARY_AGE}"
            SOVERSION ${XEUS_ZMQ_BINARY_COMPATIBLE}
            OUTPUT_NAME "lib${output_name}"
        )
    else()
        set_target_properties(
            ${target_name}
            PROPERTIES
            PUBLIC_HEADER "${XEUS_ZMQ_HEADERS}"
            COMPILE_DEFINITIONS "XEUS_ZMQ_EXPORTS"
            PREFIX ""
            VERSION ${XEUS_ZMQ_BINARY_VERSION}
            SOVERSION ${XEUS_ZMQ_BINARY_CURRENT}
            OUTPUT_NAME "lib${output_name}"
        )
    endif()

    # Compilation flags
    # =================

    target_compile_features(${target_name} PRIVATE cxx_std_14)

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
        CMAKE_CXX_COMPILER_ID MATCHES "Intel")

        target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)

        message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
    endif()

    if (${linkage_upper} STREQUAL "STATIC")
        target_compile_definitions(${target_name} PUBLIC XEUS_ZMQ_STATIC_LIB)
    endif ()

    if (MSVC)
        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
    elseif (APPLE)
        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
    else ()
        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
    endif ()

    if (XEUS_ZMQ_STATIC_DEPENDENCIES)
        if (CMAKE_DL_LIBS)
            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS})
        endif ()
        if (UNIX AND NOT APPLE)
            target_link_libraries(${target_name} PRIVATE util rt)
        endif ()
    endif ()
endmacro()

set(xeus_zmq_targets "")

if (XEUS_ZMQ_BUILD_SHARED_LIBS)
    xeus_zmq_create_target(xeus-zmq SHARED xeus-zmq)
    if(CMAKE_TARGET_SYSTEM MATCHES "Linux" AND OPENSSL_USE_STATIC_LIBS)
        # Do not reexport OpenSSL symbols from xeus, for libraries
        #   Prevents conflicts with other versions of OpenSSL
        #   loaded in the same process namespace, which can cause
        #   crashes if the versions are not compatible.
        set_target_properties(xeus-zmq PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,libcrypto.a")
    endif()
    list(APPEND xeus_zmq_targets xeus-zmq)
endif ()

if (XEUS_ZMQ_BUILD_STATIC_LIBS)
    # On Windows, a static library should use a different output name
    # to avoid the conflict with the import library of a shared one.
    if (CMAKE_HOST_WIN32)
        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq-static)
    else ()
        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq)
    endif ()

    list(APPEND xeus_zmq_targets xeus-zmq-static)
endif ()

# Tests
# =====

# We need to control from outside whether we enable testing or not. We cannot
# rely on BUILD_TESTING since it doe snot exist until CTest is included.

include(CTest)
