=== debian/changelog ===
xeus-zmq (1.1.0-2) unstable; urgency=medium

  * Source-only upload 

 -- Gordon Ball <gordon@chronitis.net>  Mon, 07 Aug 2023 07:25:01 +0000

xeus-zmq (1.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1042462)

 -- Gordon Ball <gordon@chronitis.net>  Fri, 28 Jul 2023 19:37:22 +0000
