=== debian/control ===
Source: xeus-zmq
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               cmake,
               cppzmq-dev,
               xeus-dev (>= 3.1.1~),
               nlohmann-json3-dev,
               libssl-dev,
               pkg-config,
               doctest-dev,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/jupyter-xeus/xeus-zmq
Vcs-Git: https://salsa.debian.org/science-team/xeus-zmq.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus
Rules-Requires-Root: no

Package: libxeus-zmq2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ZeroMQ middleware for xeus (library)
 xeus-zmq provides the ZMQ transport for the Jupyter kernel protocol. This
 was formerly part of libxeus but was split into a separate library for
 xeus >= 3
 .
 This package contains the shared library.

Package: xeus-zmq-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libxeus-zmq2 (= ${binary:Version}),
         xeus-dev (>= 3.1.1~),
         cppzmq-dev,
         nlohmann-json3-dev,
         libssl-dev,
Description: ZeroMQ middleware for xeus (headers)
 xeus enables custom kernel authors to implement Jupyter kernels more
 easily. It takes the burden of implementing the Jupyter Kernel protocol
 so developers can focus on implementing the interpreter part of the Kernel.
 .
 This package contains the headers and cmake config.
