=== debian/changelog ===
xeus-zmq (1.1.1-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:57 +1100

xeus-zmq (1.1.1-2build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 02:17:19 +0000

xeus-zmq (1.1.1-2) unstable; urgency=medium

  * d/control: build-depend on nlohmann-json3-dev 3.11.3, xeus 3.1.3-2
    This should resolve an issue with different versions of the nlohmann::json
    API being exposed in the libxeus API.

 -- Gordon Ball <gordon@chronitis.net>  Sun, 11 Feb 2024 22:17:47 +0100

xeus-zmq (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1

 -- Gordon Ball <gordon@chronitis.net>  Thu, 05 Oct 2023 10:35:57 +0000
