=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: xeus-zmq
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                cppzmq-dev,
-               xeus-dev (>= 3.1.1~),
-               nlohmann-json3-dev,
+               xeus-dev (>= 3.1.3-2~),
+               nlohmann-json3-dev (>= 3.11.3~),
                libssl-dev,
                pkg-config,
                doctest-dev,
@@ -32,9 +33,9 @@
 Architecture: any
 Depends: ${misc:Depends},
          libxeus-zmq2 (= ${binary:Version}),
-         xeus-dev (>= 3.1.1~),
+         xeus-dev (>= 3.1.3-2~),
          cppzmq-dev,
-         nlohmann-json3-dev,
+         nlohmann-json3-dev (>= 3.11.3~),
          libssl-dev,
 Description: ZeroMQ middleware for xeus (headers)
  xeus enables custom kernel authors to implement Jupyter kernels more
