## xeus-zmq 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -55,6 +55,9 @@
 # Test options
 option(XEUS_ZMQ_BUILD_TESTS "xeus test suite" OFF)
 
+# Option to build without libsodium
+option(XEUS_ZMQ_BUILD_WITHOUT_LIBSODIUM "Build xeus-zmq without libsodium" OFF)
+
 # Static build configuration
 # ==========================
 
@@ -79,21 +82,24 @@
 # Dependencies
 # ============
 
-set(xeus_REQUIRED_VERSION 3.1.1)
-set(nlohmann_json_REQUIRED_VERSION 3.2.0)
+set(xeus_REQUIRED_VERSION 5.0.0)
+set(nlohmann_json_REQUIRED_VERSION 3.11.3)
 set(cppzmq_REQUIRED_VERSION 4.8.1)
 set(zeromq_REQUIRED_VERSION 4.3.2)
 
 if (NOT TARGET xeus AND NOT TARGET xeus-static)
     find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found xeus ${xeus_VERSION}")
 endif ()
 
 if (NOT TARGET nlohmann_json)
     find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found nlohmann_json ${nlohmann_json_VERSION}")
 endif ()
 
 if (NOT TARGET cppzmq AND NOT TARGET cppzmq-static)
     find_package(cppzmq ${cppzmq_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found cppzmq ${cppzmq_VERSION}")
 endif ()
 
 if (NOT TARGET libzmq AND NOT TARGET libzmq-static)
@@ -123,53 +129,90 @@
 # ============
 
 set(XEUS_ZMQ_HEADERS
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xauthentication.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xclient_zmq.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xcontrol_default_runner.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xcontrol_runner.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdap_tcp_client.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdebugger_base.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xeus-zmq.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xdap_tcp_client.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_control_main.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xmiddleware.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_shell_main.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xserver_zmq_split.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xshell_default_runner.hpp
+    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xshell_runner.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xthread.hpp
     ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_context.hpp
-    ${XEUS_ZMQ_INCLUDE_DIR}/xeus-zmq/xzmq_serializer.hpp
 )
 
 set(XEUS_ZMQ_SOURCES
-    ${XEUS_ZMQ_SOURCE_DIR}/xauthentication.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xcontrol.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xdap_tcp_client.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xdebugger_base.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xheartbeat.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xmiddleware.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xpublisher.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_control_main.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_shell_main.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xserver_zmq_split.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xshell.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xshell.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xtrivial_messenger.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_context.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.hpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_messenger.cpp
-    ${XEUS_ZMQ_SOURCE_DIR}/xzmq_serializer.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_zmq.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_messenger.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_messenger.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_zmq_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xclient_zmq_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xdealer_channel.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xdealer_channel.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xheartbeat_client.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xheartbeat_client.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xiopub_client.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/client/xiopub_client.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xauthentication.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xauthentication.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xmiddleware.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xmiddleware_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xzmq_context.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xzmq_serializer.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/common/xzmq_serializer.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdap_tcp_client.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdap_tcp_client_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdap_tcp_client_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdebugger_base.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdebugger_middleware.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/debugger/xdebugger_middleware.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol_default_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xcontrol.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xheartbeat.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xheartbeat.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xpublisher.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xpublisher.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_control_main.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_control_main.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_shell_main.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_shell_main.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_default.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_default.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_split.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_split_impl.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq_split_impl.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xserver_zmq.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell_default_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xshell_runner.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xtrivial_messenger.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xtrivial_messenger.cpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xzmq_messenger.hpp
+    ${XEUS_ZMQ_SOURCE_DIR}/server/xzmq_messenger.cpp
 )
 
 # Targets and link
 # ================
 
+# Binaries that link with xeus-zmq must be able to find and load
+# libzmq. However, since xeus-zmq privately links with libzmq,
+# we need to tell cmake to append to rpath directories containing
+# linked libraries.
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
 include(CheckCXXCompilerFlag)
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)
 
-if (XEUS_ZMQ_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE)
+if (XEUS_ZMQ_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE AND NOT XEUS_ZMQ_BUILD_WITHOUT_LIBSODIUM)
 	# Explicitly finds and links with libsodium.a
 	# because it is not exported as a dependency by
 	# the static build of libzmq. Remove this when
@@ -198,10 +241,10 @@
 
     target_link_libraries(
         ${target_name}
-        PUBLIC ${CPPZMQ_TARGET_NAME}
         PUBLIC nlohmann_json::nlohmann_json
-        PUBLIC OpenSSL::Crypto
         PUBLIC ${XEUS_TARGET_NAME}
+        PRIVATE ${CPPZMQ_TARGET_NAME}
+        PRIVATE OpenSSL::Crypto
     )
 
     if (NOT MSVC)
@@ -244,77 +287,3 @@
             SOVERSION ${XEUS_ZMQ_BINARY_CURRENT}
             OUTPUT_NAME "lib${output_name}"
         )
-    endif()
-
-    # Compilation flags
-    # =================
-
-    target_compile_features(${target_name} PRIVATE cxx_std_14)
-
-    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
-        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
-        CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-
-        target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
-
-        message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
-    endif()
-
-    if (${linkage_upper} STREQUAL "STATIC")
-        target_compile_definitions(${target_name} PUBLIC XEUS_ZMQ_STATIC_LIB)
-    endif ()
-
-    if (MSVC)
-        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
-        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
-        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
-    elseif (APPLE)
-        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
-    else ()
-        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
-    endif ()
-
-    if (XEUS_ZMQ_STATIC_DEPENDENCIES)
-        if (CMAKE_DL_LIBS)
-            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS})
-        endif ()
-        if (UNIX AND NOT APPLE)
-            target_link_libraries(${target_name} PRIVATE util rt)
-        endif ()
-    endif ()
-endmacro()
-
-set(xeus_zmq_targets "")
-
-if (XEUS_ZMQ_BUILD_SHARED_LIBS)
-    xeus_zmq_create_target(xeus-zmq SHARED xeus-zmq)
-    if(CMAKE_TARGET_SYSTEM MATCHES "Linux" AND OPENSSL_USE_STATIC_LIBS)
-        # Do not reexport OpenSSL symbols from xeus, for libraries
-        #   Prevents conflicts with other versions of OpenSSL
-        #   loaded in the same process namespace, which can cause
-        #   crashes if the versions are not compatible.
-        set_target_properties(xeus-zmq PROPERTIES LINK_FLAGS "-Wl,--exclude-libs,libcrypto.a")
-    endif()
-    list(APPEND xeus_zmq_targets xeus-zmq)
-endif ()
-
-if (XEUS_ZMQ_BUILD_STATIC_LIBS)
-    # On Windows, a static library should use a different output name
-    # to avoid the conflict with the import library of a shared one.
-    if (CMAKE_HOST_WIN32)
-        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq-static)
-    else ()
-        xeus_zmq_create_target(xeus-zmq-static STATIC xeus-zmq)
-    endif ()
-
-    list(APPEND xeus_zmq_targets xeus-zmq-static)
-endif ()
-
-# Tests
-# =====
-
-# We need to control from outside whether we enable testing or not. We cannot
-# rely on BUILD_TESTING since it doe snot exist until CTest is included.
-
-include(CTest)
-
