=== debian/changelog ===
xeus-zmq (3.1.0-0.3) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * Upload to unstable.
  * debian/control:
    - xeus-zmq-dev: Depends on xeus-dev (>= 5.0.0), cppzmq-dev (>= 4.8.1)

 -- Bill Allombert <ballombe@debian.org>  Sat, 28 Dec 2024 11:11:46 +0100

xeus-zmq (3.1.0-0.2) experimental; urgency=medium

  * Non-maintainer upload.
  * debian/control:
    - Build-Depends on xeus-dev (>= 5.0.0), cppzmq-dev (>= 4.8.1)

 -- Bill Allombert <ballombe@debian.org>  Mon, 28 Oct 2024 19:18:18 +0100

xeus-zmq (3.1.0-0.1) experimental; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release
    - New soname: libxeus-zmq2 -> libxeus-zmq6
  * debian/control:
    - Build-Depends on pkgconf instead of pkg-config.
    - New library name: libxeus-zmq2 -> libxeus-zmq6
  * debian/libxeus-zmq2.install: rename to debian/libxeus-zmq6.install

 -- Bill Allombert <ballombe@debian.org>  Sat, 19 Oct 2024 13:24:44 +0200
