=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: xeus-zmq
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               cppzmq-dev,
-               xeus-dev (>= 3.1.3-2~),
+               cppzmq-dev (>= 4.8.1),
+               xeus-dev (>= 5.0.0),
                nlohmann-json3-dev (>= 3.11.3~),
                libssl-dev,
-               pkg-config,
+               pkgconf,
                doctest-dev,
 Standards-Version: 4.6.2
 Section: libs
@@ -18,7 +17,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
-Package: libxeus-zmq2
+Package: libxeus-zmq6
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: ZeroMQ middleware for xeus (library)
@@ -32,9 +31,9 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libxeus-zmq2 (= ${binary:Version}),
-         xeus-dev (>= 3.1.3-2~),
-         cppzmq-dev,
+         libxeus-zmq6 (= ${binary:Version}),
+         xeus-dev (>= 5.0.0),
+         cppzmq-dev (>= 4.8.1),
          nlohmann-json3-dev (>= 3.11.3~),
          libssl-dev,
 Description: ZeroMQ middleware for xeus (headers)
