## xeus-zmq 3.1.1

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # Unit tests
 # ==========
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.8)
 
 if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
     project(xeus-zmq-test)
