=== debian/changelog ===
xeus-zmq (3.1.1-0.1) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release.
  * debian/watch: add missing 'debian uupdate'
  * debian/control:
   - Build-Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev
   - xeus-zmq-dev: 
     + Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev

 -- Bill Allombert <ballombe@debian.org>  Fri, 31 Oct 2025 11:55:04 +0100
