=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                cmake,
                cppzmq-dev (>= 4.8.1),
                xeus-dev (>= 5.0.0),
-               nlohmann-json3-dev (>= 3.11.3~),
+               nlohmann-json3.12-dev,
                libssl-dev,
                pkgconf,
                doctest-dev,
@@ -34,7 +34,7 @@
          libxeus-zmq6 (= ${binary:Version}),
          xeus-dev (>= 5.0.0),
          cppzmq-dev (>= 4.8.1),
-         nlohmann-json3-dev (>= 3.11.3~),
+         nlohmann-json3.12-dev,
          libssl-dev,
 Description: ZeroMQ middleware for xeus (headers)
  xeus enables custom kernel authors to implement Jupyter kernels more
