## xeus-zmq 3.1.2

=== debian/changelog ===
xeus-zmq (3.1.2-1) unstable; urgency=medium

  * New upstream release.
  * New maintainer.
  * debian/control:
    - Update Standards-Version to 4.7.3
    - libxeus-zmq6: mark Multi-Arch: same
    - Remove Vcs-Git, Vcs-Browser.
  * debian/watch: add missing 'debian uupdate'

 -- Bill Allombert <ballombe@debian.org>  Wed, 25 Feb 2026 21:12:04 +0100
