=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: xeus-zmq
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Gordon Ball <gordon@chronitis.net>
+Maintainer: Bill Allombert <ballombe@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
                cppzmq-dev (>= 4.8.1),
@@ -10,16 +9,15 @@
                libssl-dev,
                pkgconf,
                doctest-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/jupyter-xeus/xeus-zmq
-Vcs-Git: https://salsa.debian.org/science-team/xeus-zmq.git
-Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
 Package: libxeus-zmq6
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
 Description: ZeroMQ middleware for xeus (library)
  xeus-zmq provides the ZMQ transport for the Jupyter kernel protocol. This
  was formerly part of libxeus but was split into a separate library for
